LeetCode OJ - Two Sum

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2


my answer:

public class Solution {
    public int[] twoSum(int[] nums, int target) {

    	int[] res = new int[2];

    	for(int x=0;x<nums.length;x++){
    		for(int y=x+1;y<nums.length;y++){
    			
    			if (nums[x] + nums[y] == target){
    				res[0] = x+1; 
    				res[1] = y+1;
 					return res;
    			}   			
    		}
    	}      
        return null;
    }
}
Runtime: 41 ms

參考: http://blog.sina.com.cn/s/blog_7bee572b0101ux4q.html

改進如下:

public class Solution_1 {
    public int[] twoSum(int[] numbers, int target) {
        int[] res = new int[2];
        HashMap<Integer,Integer> map = new HashMap<Integer,Integer>();
        for(int i = 0; i < numbers.length; i++){
            map.put(numbers[i], i);
        }
        for(int i = 0; i < numbers.length; i++){
            int gap = target - numbers[i];
            if(map.get(gap)!= null &&map.get(gap)!= i){
                res[0] = i+1;
                res[1] = map.get(gap) + 1;
                break;
            }
        }
    return res;
    }
}

Runtime: 8 ms


總結:暴力搜索,時間複雜度爲O(n*n),很簡單,但是會出現超時錯誤。

    利用HashMap,存儲數組中的值和Index,由於HashMap中查詢鍵值對的開銷是固定的,因此在性能上可以得到很大的提升。

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章